<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='WEBP_EGIDESCAN';
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';
include_once $path.'/plugin/egidescan/model_egidescan.php';
//include_once $path.$plugin_url.'/inc/Model_import-module.php';

$webp1 = Model_esia::getWebPlugin($dbconnection);
foreach ($webp1 as $value)
{
	if($value['name'] == 'WEBP_EGIDESCAN')
	{
		$plugin_url = $value['apache_path'];
		$index_page = $value['index_page'];
		break;
	}
}
$smarty->assign('plugin_url',$plugin_url);
$template_path = $plugin_url.'templates/' ;
include_once $path.$plugin_url.'/common_egidescan.php';


$file_scan_date = "/tmp/scan_date.txt";

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
// include_once $path.'/inc/common_node_control.php';

session_write_close();
try
{
		$agent_id = $_REQUEST['agent_id'];

//   		$lang_fr_CVE_severity = $lang['EGIDE_CVE_SEVERITY_TYPE'];
		$cveDetected = Model_egidescan::getCVEVulDetect($dbconnection);

		$agent_ifaces = Model_egidescan::getConfiguratedEgideBoxIfaces($dbconnection,$agent_id);
		$showed_ifaces = array();

		//Pour le tri des groupes
		$ifaces_type = array();
		foreach($agent_ifaces as $row)
		{
			$ifaces_type[$row['type_factor']][$row['type_name']] = $row;
		}

		krsort($ifaces_type);
		foreach($ifaces_type as $key => $row)
		{
			ksort($ifaces_type[$key]);
		}

		foreach($ifaces_type as $factor)
		{
			foreach($factor as $name => $row)
			{
				$showed_ifaces[$name] = array();
			}
		}


		//Récupération et analyse des vulnérability
		foreach($agent_ifaces as $key => $agent_iface)
		{
			$retRow = array();
			$vul_detected = Model_egidescan::getCVEVulDetectByIface($dbconnection,$agent_iface['id']);

			$max_score = 0;
			$total_score = 0;
			$nb_vul = 0;
				foreach($vul_detected as $vul)
			{
				if( isset($vul['cve_severt']) )
				{
					$match_vul = $vul['match_vul'];

					if( $max_score < $vul['cve_score'])
					{
						$max_score = $vul['cve_score'];
					}
					$total_score+=$vul['cve_score']*$match_vul;

					$nb_vul+=$match_vul;
				}
			}
			if( $nb_vul > 0 )
			{
				$avg_score = round($total_score / $nb_vul,1);
			}
			else
			{
				$avg_score = 0;
			}

		//	$calculed_score = round(($avg_score + $max_score) / 2,1);
			$calculed_score = $avg_score;

			$factor = $agent_iface['type_factor'];

			$calculed_score = round($calculed_score*$factor,1);

			$retRow['label'] = $agent_iface['label'];
			$retRow['value'] = $calculed_score;
			$retRow['color'] = Model_egidescan::getScoreHtmlColor($calculed_score);

			$group_name =  $agent_iface['type_name'];

			if( !isset($showed_ifaces[$group_name]['label']))
			{
				$showed_ifaces[$group_name]['label'] = $group_name;
				$showed_ifaces[$group_name]['factor'] = $factor;
				$showed_ifaces[$group_name]['color'] =  $agent_iface['type_color'];
				$showed_ifaces[$group_name]['ifaces'] = array();
				$factor_list[] = $factor;
			}
			$showed_ifaces[$group_name]['ifaces'][] = $retRow;
		}

		$devices_table = Model_egidescan::getDevicesOfAgent($dbconnection,$agent_id);
		$nodes_list_id = array();

		foreach($devices_table as $row)
		{
			$nodes_list_id[] = $row['eg_device_id'];
		}

		$listcve = Model_egidescan::getCVEByScoring($dbconnection,$user->getId(),$nodes_list_id,10);
        $arr=array();
        foreach($listcve as $cve)
        {
            $l_complexity = $cve['complexity'];
            if(array_key_exists('EGIDE_CVE_SEVERITY_TYPE_'.$l_complexity,$lang))
            {
                $l_complexity =$lang['EGIDE_CVE_SEVERITY_TYPE_'.$l_complexity];
            }
            $l_severity= $cve['severity'];
            if(array_key_exists('EGIDE_CVE_SEVERITY_TYPE_'.$l_severity,$lang))
            {
                $l_severity =$lang['EGIDE_CVE_SEVERITY_TYPE_'.$l_severity];
            }
            $arr[]=array('id' => $cve['id'],
				            'description' => $cve['description'],
				            'scoring' => $cve['scoring'],
				            'severity' => $l_severity,
				            'complexity' => $l_complexity,
				            'number' => $cve['number'],
                            'css'=> getCSSClassByscore($cve['scoring'])
			            );
        }
		$smarty->assign('vulnerability_array',$arr);

		$classed_severity = array(); $paramColor = array();
		for($i=0;$i<10;$i++)
		{
			$classed_severity[$i]=0;
		}
		foreach($all_scores as $value)
		{
			if(isset($value))
			{
				if($value==10)
				{
					$classed_severity[9] ++ ;
				}
				else
				{
					$classed_severity[floor($value)] ++ ;
				}
			}
		}
		array_unshift($classed_severity, 'severity');

		$severity_class = array();
		for($i=0;$i<10;$i++)
		{
			$j = $i+1 ;
			$severity_class[$i]="$i - $j";
		}
		// array_unshift($severity_class, 'x');

		$smarty->assign('var_chart_culumn_x',$severity_class);
		$smarty->assign('var_chart_culumn_y',$classed_severity);

		$nodeInfo = Model_egidescan::getNodesByScoring($dbconnection,$user->getId(),$nodes_list_id,10);
		$ret = array();
		foreach($nodeInfo as $node)
		{
			$ret[]=array('id' => $node['id'],
							'name' => $node['name'],
							'type' => $node['type'],
							'address' => $node['ip'],
							'description' => $node['description'],
							'scoring' => $node['averageVulnerabilityScoring'],
							'vul_number' => $node['numberVulnerability'],
							'score_max' => $node['maxVulnerabilityScoring'],
							'css'=> getCSSClassByscore($node['averageVulnerabilityScoring']),
							'css_max'=> getCSSClassByscore($node['maxVulnerabilityScoring'])
						);
		}
		$smarty->assign('nodesScorringTop',$ret);
		$smarty->assign('ifaces_list',$showed_ifaces);

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%";



}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('errors',$e->getMessage());
}
$smarty->display($path.$template_path.'dialog_interface.html');
?>
